## mx-viewer 26.01.4

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2017-2025 MX Authors
# *
# * Authors: Adrian
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of mx-viewer.
# *
# * mx-viewer is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * mx-viewer is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with mx-viewer.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
endif()

project(mx-viewer
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "MX Viewer - Lightweight web browser for MX Linux"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    WebEngineWidgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    src/main.cpp
    src/mainwindow.cpp
    src/webview.cpp
    src/tabwidget.cpp
    src/addressbar.cpp
    src/downloadwidget.cpp
)

set(HEADERS
    src/mainwindow.h
    src/webview.h
    src/tabwidget.h
    src/addressbar.h
    src/downloadwidget.h
)

set(UI_FILES
    src/downloadwidget.ui
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(mx-viewer
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(mx-viewer
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
    Qt6::WebEngineWidgets
)

# Set compiler flags
target_compile_options(mx-viewer PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(mx-viewer PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(mx-viewer PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(mx-viewer PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
    VERSION="${PROJECT_VERSION}"
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(mx-viewer PRIVATE NDEBUG)
    target_compile_options(mx-viewer PRIVATE -O3)

    # Add LTO - different flags for different compilers
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(mx-viewer PRIVATE -flto=thin)
        target_link_options(mx-viewer PRIVATE -flto=thin)
    else()
        target_compile_options(mx-viewer PRIVATE -flto=auto)
        target_link_options(mx-viewer PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(mx-viewer
    TS_FILES ${TRANSLATION_FILES}
    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
    QM_FILES_OUTPUT_VARIABLE qm_files
)

# Set target properties
set_target_properties(mx-viewer PROPERTIES
    OUTPUT_NAME "mx-viewer"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Add include directories for headers
target_include_directories(mx-viewer PRIVATE
    ${CMAKE_SOURCE_DIR}/src
)

# Install target (required by Debian build system)
# Other files are handled by debian/install
install(TARGETS mx-viewer
    RUNTIME DESTINATION bin
)

## mx-viewer 17.1mx16

=== debian/changelog ===
mx-viewer (17.1mx16) mx; urgency=medium

  * add search to toolbar, display toolbar permanently

 -- Adrian <adrian@mxlinux.org>  Fri, 13 Jan 2017 13:03:38 -0500

mx-viewer (16.10mx16) mx; urgency=medium

  * changed URLs

 -- Adrian <adrian@mxlinux.org>  Mon, 10 Oct 2016 14:59:38 -0400

mx-viewer (15.12.1mx15) mx; urgency=medium

  * version bump

 -- Adrian <adrian@mxlinux.org>  Wed, 23 Dec 2015 09:02:16 -0500

mx-viewer (15.12mx15) mx; urgency=medium

  * moved icon location

 -- Adrian <adrian@mxlinux.org>  Tue, 01 Dec 2015 08:56:57 -0500

mx-viewer (15.7.1mx15) mx; urgency=medium

  * added build-deps, fixed license

 -- Adrian <adrian@mxlinux.org>  Thu, 09 Jul 2015 18:52:14 -0400

mx-viewer (15.7mx15) mx; urgency=medium

  * update to qt5 

 -- Adrian <adrian@mxlinux.org>  Tue, 30 Jun 2015 14:15:45 -0400

mx-viewer (15.4.1mx14) mx; urgency=medium

  * Provides: x-www-browser.
  * Add qtchooser and qt4-default as build-depends to avoid any Qt 5
    and Qt 3 qmake issues on other platforms.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Sat, 06 Jun 2015 19:05:48 -0700

mx-viewer (15.4mx14) mx; urgency=medium

  * added zoom in +, zoom out -, restore size 0

 -- Adrian <adrian@mxlinux.org>  Wed, 01 Apr 2015 17:23:57 -0400

mx-viewer (15.3mx14) mx; urgency=medium

  * added progress bar

 -- Adrian <adrian@mxlinux.org>  Fri, 13 Mar 2015 12:16:37 -0400

mx-viewer (15.2) mx; urgency=medium

  * added search feature.

 -- Adrian <adrian@mxlinux.org>  Mon, 16 Feb 2015 10:08:03 -0500

mx-viewer (0.14.2mx142+1) mx; urgency=low

  * Initial packaging.

 -- Adrian <adrian@mxlinux.org>  Sun, 27 Jul 2014 16:13:13 -0400

=== debian/control ===
Source: mx-viewer
Section: system
Priority: optional
Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=7.0.50~),
	qt5-qmake,
	qt5-default,
	qttools5-dev-tools,
        libqt5webkit5-dev
Standards-Version: 3.9.4
Homepage: https://github.com/AdrianTM/mx-viewer

Package: mx-viewer
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: x-www-browser 
Description: Displays a URL in a window
 MX Viewer displays a URL in a new window. It's an utility program used for
 displaying help information by various MX Linux utilities

=== debian/rules ===
#!/usr/bin/make -f

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake-qt5 LRELEASE=lrelease-qt5 QMAKE_OPTS="$(QMAKE_OPTS)"
export QT_SELECT=qt5

override_dh_auto_clean:
	dh_auto_clean

override_dh_auto_build:
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_builddeb:
	dh_builddeb -- -Z xz

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --parallel

## mx-viewer 18.8

=== debian/changelog ===
mx-viewer (18.8) mx; urgency=medium

  * fix icon other themes

 -- Adrian <adrian@mxlinux.org>  Sat, 11 Aug 2018 23:28:47 -0400

mx-viewer (18.3) mx; urgency=medium

  * dropping rights if ran as root

 -- Adrian <adrian@mxlinux.org>  Tue, 13 Mar 2018 19:15:36 -0400

=== debian/control ===
Source: mx-viewer
Section: system
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=9),
	qt5-qmake,
	qt5-default,
	qttools5-dev-tools,
        libqt5webkit5-dev
Standards-Version: 3.9.8
Homepage: https://github.com/AdrianTM/mx-viewer

Package: mx-viewer
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: x-www-browser 
Description: Displays a URL in a window
 MX Viewer displays a URL in a new window. It's an utility program used for
 displaying help information by various MX Linux utilities

## mx-viewer 19.8

=== debian/changelog ===
mx-viewer (19.8) mx; urgency=medium

  * save window geometry

 -- Adrian <adrian@mxlinux.org>  Sat, 24 Aug 2019 03:59:08 -0400

=== debian/control ===
Source: mx-viewer
Section: system
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=9),
               libqt5webkit5-dev,
               qt5-default,
               qt5-qmake,
               qttools5-dev-tools
Standards-Version: 3.9.8
Homepage: https://github.com/AdrianTM/mx-viewer

Package: mx-viewer
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: x-www-browser
Description: Displays a URL in a window
 MX Viewer displays a URL in a new window. It's an utility program used for
 displaying help information by various MX Linux utilities

## mx-viewer 19.10

=== debian/changelog ===
mx-viewer (19.10) mx; urgency=medium

  * update color scheme handling 

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sat, 12 Oct 2019 13:16:47 -0400

mx-viewer (19.9) mx; urgency=medium

  * minor change: show program name when displaying version

 -- Adrian <adrian@mxlinux.org>  Sun, 29 Sep 2019 15:11:19 -0400

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,7 @@
 Maintainer: Adrian <adrian@mxlinux.org>
 Build-Depends: debhelper (>=9),
                libqt5webkit5-dev,
-               qt5-default,
-               qt5-qmake,
+               qtbase5-dev,
                qttools5-dev-tools
 Standards-Version: 3.9.8
 Homepage: https://github.com/AdrianTM/mx-viewer

## mx-viewer 19.10.01

=== debian/changelog ===
mx-viewer (19.10.01) mx; urgency=medium

  * security improvements

 -- Adrian <adrian@mxlinux.org>  Sun, 13 Oct 2019 23:05:10 -0400

## mx-viewer 20.12

=== debian/changelog ===
mx-viewer (20.12) mx; urgency=medium

  * added command line options to enable/disable javascript, 3rd party cookies, spatial navigation, etc
  * default to duckduckgo instead of google
  * fix: remember window size

 -- Adrian <adrian@mxlinux.org>  Sun, 27 Dec 2020 03:14:41 -0500

## mx-viewer 20.12.01

=== debian/changelog ===
mx-viewer (20.12.01) mx; urgency=medium

  * add open/browse option, help dialog 

 -- Adrian <adrian@mxlinux.org>  Mon, 28 Dec 2020 02:33:29 -0500

## mx-viewer 21.1

=== debian/changelog ===
mx-viewer (21.1) mx; urgency=medium

  * show which URL failed to load
  * various fixes

 -- Adrian <adrian@mxlinux.org>  Wed, 27 Jan 2021 11:44:36 -0500

## mx-viewer 21.8

=== debian/changelog ===
mx-viewer (21.8) mx; urgency=medium

  * Save .conf file in ~/.config/MX-Linux

 -- Adrian <adrian@mxlinux.org>  Sun, 01 Aug 2021 21:39:18 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: system
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper (>=9),
+Build-Depends: debhelper (>=10),
                libqt5webkit5-dev,
                qtbase5-dev,
                qttools5-dev-tools

## mx-viewer 22.5

=== debian/changelog ===
mx-viewer (22.5) mx; urgency=medium

  * Use webenginewidgets instead of webkitwidgets
  * Save .conf file in ~/.conf/MX-Linux

 -- Adrian <adrian@mxlinux.org>  Tue, 24 May 2022 22:37:53 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
 Build-Depends: debhelper (>=10),
-               libqt5webkit5-dev,
+               qtwebengine5-dev,
                qtbase5-dev,
                qttools5-dev-tools
 Standards-Version: 3.9.8

## mx-viewer 22.5.01

=== debian/changelog ===
mx-viewer (22.5.01) mx; urgency=medium

  * Improve search behavior: 
  *     - focus search by default
  *     - Shift-F3 searches backwards
  *     - Esc clears the search field, second Esc focuses the document
  * Fix reload shortcut

 -- Adrian <adrian@mxlinux.org>  Thu, 26 May 2022 02:10:44 -0400

## mx-viewer 22.6

=== debian/changelog ===
mx-viewer (22.6) mx; urgency=medium

  * Make it look and work more like a browser. Added:
  * 	- address bar by default
  *	- downlod capability and a basic download manager
  *	- menu
  * 	- favorites (basic function to add, move, remove and save and reload)
  *	- full-size mode
  *	- zoom in/out buttons
  *	- home button: configurable in ~/.config/MX-Linux/mx-viewer.conf Home="url"

 -- Adrian <adrian@mxlinux.org>  Thu, 02 Jun 2022 00:11:26 -0400

## mx-viewer 22.6.01

=== debian/changelog ===
mx-viewer (22.6.01) mx; urgency=medium

  * Save history between sessions
  * Added option to clear history, or individual item
  * Add option to rename bookmarks
  * Fix bug saving bookmarks

 -- Adrian <adrian@mxlinux.org>  Fri, 10 Jun 2022 08:25:21 -0400

## mx-viewer 23.7

=== debian/changelog ===
mx-viewer (23.7) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Thu, 20 Jul 2023 17:44:11 -0400

## mx-viewer 23.7.01

=== debian/changelog ===
mx-viewer (23.7.01) mx; urgency=medium

  * update language processing

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sat, 22 Jul 2023 16:17:44 -0400

## mx-viewer 23.7.02

=== debian/changelog ===
mx-viewer (23.7.02) mx; urgency=medium

  * Open files without specifying the full path

 -- Adrian <adrian@mxlinux.org>  Thu, 27 Jul 2023 00:02:20 -0400

## mx-viewer 23.8

=== debian/changelog ===
mx-viewer (23.8) mx; urgency=medium

  * Implemented tab interface
  * Open link (right-click menu, or with target _blank) in new tab, or new window
  * Enabled show source

 -- Adrian <adrian@mxlinux.org>  Sat, 19 Aug 2023 23:13:22 -0400

## mx-viewer 23.9

=== debian/changelog ===
mx-viewer (23.9) mx; urgency=medium

  * Fix: key press event not being processed
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Sep 2023 13:06:51 -0400

## mx-viewer 24.3

=== debian/changelog ===
mx-viewer (24.3) mx; urgency=medium

  * Update translations 

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 13:19:44 -0400

=== debian/control ===
--- 
+++ 
@@ -15,4 +15,5 @@
 Provides: x-www-browser
 Description: Displays a URL in a window
  MX Viewer displays a URL in a new window. It's an utility program used for
- displaying help information by various MX Linux utilities
+ displaying help information by various MX Linux utilities. It can also be used
+ as a very basic internet browser.

## mx-viewer 25.7

=== debian/changelog ===
mx-viewer (25.7) mx; urgency=medium

  * Change default home page to start.duckduckgo.com (might need to change
    ~/.config/MX-Linux/mx-viewer.conf)

 -- Adrian <adrian@mxlinux.org>  Thu, 03 Jul 2025 13:08:57 -0400

mx-viewer (24.4) mx; urgency=medium

  * Update to Qt6

 -- Adrian <adrian@mxlinux.org>  Thu, 24 Apr 2025 20:48:22 -0400

=== debian/control ===
Source: mx-viewer
Section: web
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools,
               qt6-webengine-dev
Standards-Version: 3.9.8
Homepage: https://github.com/AdrianTM/mx-viewer
Vcs-Git: https://github.com/AdrianTM/mx-viewer.git
Vcs-Browser: https://github.com/AdrianTM/mx-viewer
Rules-Requires-Root: no

Package: mx-viewer
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: x-www-browser
Description: Lightweight web browser for MX Linux
 MX Viewer is a lightweight browser that displays URLs in a clean window.
 It serves as the default help viewer for MX Linux applications and
 can also function as a basic web browser with minimal resource usage.
 Features include:
  * Fast page loading
  * Simple, distraction-free interface
  * Integration with MX Linux desktop environment

## mx-viewer 26.01

=== debian/changelog ===
mx-viewer (26.01) mx; urgency=medium

  * Add close and reopen tab shortcuts
  * Various UI improvements
  * Added Settings page
  * Added Bookmark editor
  * Added F12 dev tools
  * Ctrl-click and middle-click open tab in background

 -- Adrian <adrian@mxlinux.org>  Tue, 13 Jan 2026 21:55:54 -0500

## mx-viewer 26.01.1

=== debian/changelog ===
mx-viewer (26.01.1) mx; urgency=medium

  * Added cookies, 3rd party cookies, pop-up options in Settings
  * Added + icon for opening new tab
  * Added option to save tabs on closing and resume next time the app starts

 -- Adrian <adrian@mxlinux.org>  Wed, 14 Jan 2026 13:41:01 -0500

## mx-viewer 26.01.2

=== debian/changelog ===
mx-viewer (26.01.2) mx; urgency=medium

  * Added Ctrl-R, Alt <- and Alt -> navigation keys
  * Added a History page accessible with Ctrl-H
  * Added a Settings page accessible with Ctrl-,
  * Added address bar autocompletion from history
  * Added default search when the address bar doesn't contain a valid domain
  * Save/restore window geometry

 -- Adrian <adrian@mxlinux.org>  Wed, 14 Jan 2026 22:42:23 -0500

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

override_dh_auto_configure:
	dh_auto_configure -- \
		-G Ninja \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build/
	rm -f translations/*.qm
	rm -f src/version.h

override_dh_auto_build:
	/usr/lib/qt6/bin/lrelease translations/*.ts
	dh_auto_build

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_test:
	# Skip tests as no test targets are defined

override_dh_auto_install:
	# Install is handled by debian/install file
	dh_auto_install

%:
	dh $@ --buildsystem=cmake+ninja --no-automatic-dbgsym

## mx-viewer 26.01.4

=== debian/changelog ===
mx-viewer (26.01.4) mx; urgency=medium

  * Add button to clear cookies and cache
  * Preserve cookies between sessions

 -- Adrian <adrian@mxlinux.org>  Fri, 16 Jan 2026 18:11:33 -0500

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,9 @@
 Section: web
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper-compat (= 13),
-               qt6-base-dev,
-               qt6-base-dev-tools,
-               qt6-tools-dev,
-               qt6-tools-dev-tools,
-               qt6-webengine-dev
+Build-Depends: debhelper-compat (=12), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools, qt6-webengine-dev
 Standards-Version: 3.9.8
-Homepage: https://github.com/AdrianTM/mx-viewer
-Vcs-Git: https://github.com/AdrianTM/mx-viewer.git
+Vcs-Git: https://github.com/AdrianTM/mx-viewer
 Vcs-Browser: https://github.com/AdrianTM/mx-viewer
 Rules-Requires-Root: no
